unit Plane;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Tiles;

type
  TFormPlane = class(TForm)
    Timer1: TTimer;
    Img: TImage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure ReInit;
    procedure ReDraw;    
    { Public declarations }
  end;

var
  FormPlane: TFormPlane;

implementation

uses Main;

{$R *.dfm}

procedure TFormPlane.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FormMain.AerialView1.Checked := False;
end;

procedure TFormPlane.ReInit;
begin
  FormPlane.ClientWidth := FormMain.MapWidth * 3;
  FormPlane.ClientHeight := FormMain.MapHeight * 3;
  Img.Width := FormPlane.ClientWidth;
  Img.Height := FormPlane.ClientHeight;
end;

procedure TFormPlane.ReDraw;
var
  I, J: Integer;
begin
  Img.Picture := nil;
  Img.Picture.Bitmap := TBitmap.Create;
  Img.Picture.Bitmap.Width := Img.Width;
  Img.Picture.Bitmap.Height := Img.Height;
  for J := 0 to FormMain.MapHeight - 1 do
    for I := 0 to FormMain.MapWidth - 1 do
      if FormMain.Map[I, J].Tag = 0 then
      begin
        Img.Picture.Bitmap.Canvas.Pixels[3*I, 3*J] := clWhite;
        Img.Picture.Bitmap.Canvas.Pixels[3*I+1, 3*J] := clWhite;
        Img.Picture.Bitmap.Canvas.Pixels[3*I, 3*J+1] := clWhite;
        Img.Picture.Bitmap.Canvas.Pixels[3*I+1, 3*J+1] := clWhite;
      end
      else
      begin
        Img.Picture.Bitmap.Canvas.Pixels[3*I, 3*J] := clBlack;
        Img.Picture.Bitmap.Canvas.Pixels[3*I+1, 3*J] := clBlack;
        Img.Picture.Bitmap.Canvas.Pixels[3*I, 3*J+1] := clBlack;
        Img.Picture.Bitmap.Canvas.Pixels[3*I+1, 3*J+1] := clBlack;
      end;
end;

procedure TFormPlane.FormShow(Sender: TObject);
begin
  Top := FormMain.Top + 30;
  Left := Screen.Width - Width - 25;
end;

procedure TFormPlane.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
end;

end.
