unit TileSelector;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Tiles, StdCtrls;

type
  TFormTlSel = class(TForm)
    Sh: TShape;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure SelectTile(Sender: TObject);
  public
    TileIndex: Byte;
    ImgBmp: array of TImage;
    ImgFmp: array of TImage;
    procedure LoadTiles;
    { Public declarations }
  end;

var
  FormTlSel: TFormTlSel;
  ImgCount: Integer = 0;

implementation

uses Main;

{$R *.dfm}

procedure TFormTlSel.LoadTiles;
var
  I: Integer;
begin
  for I := 0 to ImgCount - 1 do
  begin
    ImgBmp[I].Free;
    ImgFmp[I].Free;
  end;
  ImgCount := FormMain.Tl.TileCount;

  SetLength(ImgBmp, ImgCount);
  SetLength(ImgFmp, ImgCount);

  for I := 0 to FormMain.Tl.TileCount - 1 do
  begin
    ImgBmp[I] := TImage.Create(FormTlSel);
    ImgBmp[I].Parent := FormTlSel;
    ImgBmp[I].Left := 10;
    ImgBmp[I].Top := 10 + (I * (TileHeight + 10));
    ImgBmp[I].Width := TileWidth;
    ImgBmp[I].Height := TileHeight;
    ImgBmp[I].Picture.Bitmap.Assign(FormMain.Tl.GetBitmap(I));
    ImgBmp[I].Picture.Bitmap.PixelFormat := pf32bit;
    ImgBmp[I].Transparent := True;
    ImgBmp[I].Picture.Bitmap.TransparentColor := clFuchsia;
    ImgBmp[I].Picture.Bitmap.Transparent := True;
    ImgBmp[I].Tag := I;
    ImgBmp[I].OnClick := SelectTile;

    ImgFmp[I] := TImage.Create(FormTlSel);
    ImgFmp[I].Parent := FormTlSel;
    ImgFmp[I].Left := TileWidth + 15;
    ImgFmp[I].Top := 10 + (I * (TileHeight + 10));
    ImgFmp[I].Width := TileWidth;
    ImgFmp[I].Height := TileHeight;
    FormMain.Tl.AssignFreemapToBitmap(I, ImgFmp[I].Picture.Bitmap);
    ImgFmp[I].Picture.Bitmap.PixelFormat := pf32bit;
    ImgFmp[I].Transparent := True;
    ImgFmp[I].Picture.Bitmap.TransparentColor := clFuchsia;
    ImgFmp[I].Picture.Bitmap.Transparent := True;
    ImgFmp[I].Tag := I;
    ImgFmp[I].OnClick := SelectTile;
  end;
  TileIndex := 0;
  Sh.Top := 5;
  Sh.Visible := True;
end;

procedure TFormTlSel.SelectTile(Sender: TObject);
begin
  TileIndex := TImage(Sender).Tag;
  Sh.Top := TImage(Sender).Top - 5;
end;

procedure TFormTlSel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FormMain.Tiles1.Checked := False;
end;

procedure TFormTlSel.FormShow(Sender: TObject);
begin
  Left := Screen.Width - Width - 25;
end;

end.
